	.model tiny
	.data
x0	dw 0
x1	dw 0
y0	dw 0
y1	dw 0
barva	db 0
hlAX	db 0

	.code
	org  100h
start:	mov  ah, 0Fh
	int  10h
	cbw
	push ax			; uloz rezim
	mov  al, 13h
	int  10h		; nastav graficky rezim

	mov  dx, 03C8h
	xchg al, ah
	out  dx, al		; vstup pro paletu
	inc  dx
	mov  cl, 255

paleta:	cmp  cl, 192		; 0-63
	jb   short druha
	xor  al, al		; R = 0
	mov  bx, cx		; G = 0
	neg  bl
	dec  bl			; B = 0..63
	jmp  short pal

druha:	cmp  cl, 128		; 64-127
	jb   short treti
	mov  bx, cx		; G = 0
	sub  bl, 128		; B = 63..0
	mov  al, 63		; R = 0..63
	sub  al, bl
	jmp  short pal

treti:	cmp  cl, 64		; 128-191
	jb   short ctvrta
	mov  al, cl		; B = 63..0
	sub  al, 64
	mov  bl, 63
	sub  bl, al		; R = 0..63
	mov  bh, bl		; G = B
	jmp  short pal

ctvrta:	mov  al, cl 		; 192-255
	neg  al
	sub  al, 192		; R = 63..0
	mov  bx, 3F3Fh		; G = B = 63

pal:	out  dx, al		; nastavim R
	mov  al, bh
	out  dx, al		; nastavim G
	mov  al, bl		
	out  dx, al		; nastavim B
	loop short paleta

	mov  ax, 0A000h
	mov  es, ax		; zacatek videoram
	mov  cl, 0FFh

proN:	mov  al, cl		; je N liche?
	shr  al, 1
	jc   short liche

	mov  [x0], 0
	mov  [y0], 199
	mov  [x1], 255
	sub  [x1], cx
	mov  [y1], 0
	jmp  short Kresli

liche:	mov  [x0], 256
	mov  [y0], 0
	mov  [x1], 64
	add  [x1], cx
	mov  [y1], 199

Kresli:	mov  [barva], cl
	call Bress
	loop short proN
		
	mov  ah, 8
	int  21h
	pop  ax
	int  10h		; vratime puvodni graf. rezim
	ret

Bress:	push cx

	mov  ax,320
	mov  bp, ax		; posun nahoru/dolu
	mul  [y0]
	mov  di, ax
	add  di, [x0]		; DI = 320*y + x
	mov  si, 1		; posun doleva/doprava

	mov  ax, [x1]		; abs(x1 - x0)
	sub  ax, [x0]
	jnc  short nneg1
	neg  ax
	neg  si			; zmen smer citani

nneg1: 	mov  bx, [y1]		; abs(y1-y0)
	sub  bx, [y0]
	jnc  short nneg2
	neg  bx
	neg  bp			; zmen smer citani

nneg2:	cmp  al, bl
	jnc  short hlavx
	xchg al, bl		; prohod osy
	xchg si, bp

hlavx:	mov  cl, al
	inc  cl
	mov  dl, al
	shr  dl, 1
	neg  dl			; - polovina hlavni osy
        mov  [hlAX], al
	mov  al,[barva]

cara:	mov  byte ptr es:[di], al
	add  di, si		; posunu se po hlavni ose
	add  dl, bl		; zvysim citac pro vedlejsi osu
	jnc  short nic
	sub  dl, [hlAX]		; snizim citac
	add  di, bp		; pridam vedlejsi osu
nic:	loop short cara		; a opakuju do znova

        pop cx
        ret
	end start